# Auction Slim + React

## To run app use:
from root of the project with docker-compose.yml file:

```sh
docker compose up -d
```

+ Network `auction_default` Created
+ Container `auction-frontend-1`  Created

By default docker-compose automaticly create network with name `auction_default`
prefix for containers name taked from root project directory name.

Stop the container
```sh
docker compose down
```
Output:
```
[+] Running 2/2
 ✔ Container auction-frontend-1  Removed
 ✔ Network auction_default       Removed]
```

Override dault project-prefix by define envvar:

```sh
COMPOSE_PROJECT_NAME=site docker compose up -d
```
Output:
```
[+] Running 2/2
 ✔ Network site_default       Created
 ✔ Container site-frontend-1  Started
```

in file `.env` you can define own EnvVars for docker and docker-compose.
Variables defined in this file you can use inside docker-compose.yml
Because Docker Compose allows to use EnvVars in its config files.

## Best Practices Makefile

Best Practices: to list frequently used commands in a Makefile.
This allows you to create aliases for convenience of development

Now you can use this commands for Run and Stop the project:
```sh
make up
make down
```

### Flag --remove-orphans
Useful for development then you edit the docker-compose.yml file
and add, rename or delete some containers when some of it already runned.

```sh
docker compose down --remove-orphans
```
How its work: lookup for all containers with same project prefics and remove it too


### Makefile init: usefull command to recreate the project with full cleanup

Rebuild the project completely from scratch, deleting everything that came
before. Or then you clone this repository and want to up all project
When you change your config files you need to rebuild yours docker containers.
App files mounts into containers as volumes and don't needs to rebuild.

flag `--pull` say to docker-compose to pull new version of image defined in Dockerfile
(like image with new nginx version)
```
	docker compose build --pull
```

### Flag -v on docker compose down -- to remove all volumes
It useful then you want to remove all persistent data generated by your project.

docker-down-clear:
	docker compose down -v --remove-orphans

